/*
  LockedList.h

  Header for LockedList NSIS plug-in by Afrow UK.
*/

#define TEXT_HEADING         TEXT("Please close the following programs before continuing with setup...")
#define TEXT_NOPROGRAMS      TEXT("No programs that have to be closed are running")
#define TEXT_SEARCHING       TEXT("Searching, please wait...")
#define TEXT_SEARCHING_0     TEXT("0% ") ## TEXT_SEARCHING
#define TEXT_ENDSEARCH       TEXT("Cancelling search, please wait...")
#define TEXT_ENDMONITOR      TEXT("Ending program monitoring, please wait...")
#define TEXT_MSGBOX_CLOSE    TEXT("To continue with setup, the listed processes must be closed.\r\nWould you like to close them now?")
#define TEXT_MSGBOX_KILL     TEXT("Some processes could not be closed safely.\r\nWould you like to kill them?\r\n\r\nWARNING: Any unsaved data will be lost!")
#define TEXT_MSGBOX_ACFAILED TEXT("Not all processes appear to be closed.\r\nPlease close them manually to proceed with setup.")
#define TEXT_COLHEADING_1    TEXT("Application")
#define TEXT_COLHEADING_2    TEXT("Process")

#define ICON_INFO   TEXT("info.ico")
#define ICON_SEARCH TEXT("search.ico")

// Global variables.
// [[

HINSTANCE g_hInstance;
HWND      g_hWndParent;
HWND      g_hDialog, g_hList, g_hNext, g_hBack, g_hCancel, g_hProgress;
DLGPROC   ParentDlgProcOld;
WNDPROC   ListWndProcOld;
BOOL CALLBACK ParentDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL g_done = FALSE, g_is_cancel = FALSE, g_is_back = FALSE;
HCURSOR   g_hProcessingCursor;

BOOL      g_bAutoClose = FALSE;
BOOL      g_bAutoClosing = FALSE;
int       g_iRunning = 0;

#define   MAX_LIST_COUNT 128
TCHAR     *FilesList[MAX_LIST_COUNT];
TCHAR     *ModulesList[MAX_LIST_COUNT];
TCHAR     *ClassesList[MAX_LIST_COUNT];
TCHAR     *CaptionsList[MAX_LIST_COUNT];
int       FilesCount = 0;
int       ModulesCount = 0;
int       ClassesCount = 0;
int       CaptionsCount = 0;

#define   MAX_PROCESSES_COUNT 256
DWORD     ProcessIdsList[MAX_PROCESSES_COUNT];
TCHAR     *ProcessCaptionsList[MAX_PROCESSES_COUNT];
TCHAR     *ProcessFullPathsList[MAX_PROCESSES_COUNT];
int       ProcessCount = 0;

int       g_iPercentComplete = 0;
HANDLE    g_hThreadFiles = NULL;
HANDLE    g_hThreadAutoClose = NULL;

#define   PARAMS 11
TCHAR     *g_pszParams[PARAMS];

/*

  g_pszParams:
  0  = Heading text
  1  = No programs message text
  2  = Searching message text
  3  = Cancelling file search text
  4  = Ending process monitoring text
  5  = Allow next button click
  6  = Auto close failed text
  7  = Auto close text
  8  = Auto close kill text
  9  = Column heading 1
  10 = Column heading 2
  11 = Old next button text

*/

BOOL      g_bShowRunningApplications = FALSE;
BOOL      g_bUserIcons = FALSE;

enum OUT_WHERE
{
  OutListBox,
  OutStack
};

struct ITEM_TAG
{
  HWND hWnd;
  DWORD dwProcessId;
};

struct FileList
{
  TCHAR     **List;
  int       ListCount;
  OUT_WHERE OutWhere;
  int       OutOfPC;
  int       LastPC;
  BOOL      Applications;
};

// ]]

// Definitions for backwards compatibility.
// [[

#ifndef GetWindowLongPtr
#define GetWindowLongPtr GetWindowLong
#endif

#ifndef SetWindowLongPtr
#define SetWindowLongPtr SetWindowLong
#endif

#ifndef GWLP_WNDPROC
#define GWLP_WNDPROC GWL_WNDPROC
#endif

#ifndef DWLP_DLGPROC
#define DWLP_DLGPROC DWL_DLGPROC
#endif

#ifndef LVS_EX_LABELTIP
#define LVS_EX_LABELTIP 0x00004000
#endif

// ]]

// NSIS stack return values.
// [[

#define OUT_ERROR  TEXT("error")
#define OUT_NEXT   TEXT("next")
#define OUT_BACK   TEXT("back")
#define OUT_CANCEL TEXT("cancel")
#define OUT_START  TEXT("/start")
#define OUT_END    TEXT("/end")
#define OUT_DONE   TEXT("/done")
#define OUT_WAIT   TEXT("/wait")

// ]]

#ifndef GET_X_LPARAM
#define GET_X_LPARAM(lp) ((int)(short)LOWORD(lp))
#endif

#ifndef GET_Y_LPARAM
#define GET_Y_LPARAM(lp) ((int)(short)HIWORD(lp))
#endif

static BOOL CALLBACK ParentDlgProc(HWND, UINT, WPARAM, LPARAM);
static LRESULT CALLBACK DlgProc(HWND, UINT, WPARAM, LPARAM);
int my_atoi(TCHAR *);
int wildcmp(const TCHAR *, const TCHAR *);
