#ifndef SYSTEMENUM_H_INCLUDED
#define SYSTEMENUM_H_INCLUDED

#ifndef WINNT
#error You need Windows NT to use this source code. Use /D "WINNT" compiler switch.
#endif

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef GetWindowLongPtr
#define GetWindowLongPtr GetWindowLong
#endif

typedef DWORD (WINAPI *PNtQueryObject)(HANDLE, DWORD, VOID*, DWORD, VOID*);
typedef DWORD (WINAPI *PNtQuerySystemInformation)(DWORD, VOID*, DWORD, ULONG*);
typedef DWORD (WINAPI *PNtQueryInformationFile)(HANDLE, PVOID, PVOID, DWORD, DWORD);
typedef DWORD (WINAPI *PEnumProcesses)(DWORD*, DWORD, DWORD*);
typedef DWORD (WINAPI *PEnumProcessModules)(HANDLE, HMODULE*, DWORD, LPDWORD);
typedef DWORD (WINAPI *PGetModuleFileNameEx)(HANDLE, HMODULE, LPTSTR, DWORD);
static PNtQuerySystemInformation  NtQuerySystemInformation;
static PNtQueryObject             NtQueryObject;
static PNtQueryInformationFile    NtQueryInformationFile;
static PEnumProcesses             EnumProcesses;
static PEnumProcessModules        EnumProcessModules;
static PGetModuleFileNameEx       GetModuleFileNameEx;

enum FILE_INFORMATION_CLASS
{
  FileNameInformation = 9
};

enum SYSTEM_INFO_CLASS
{
  SystemHandleInformation = 16
};

enum OBJECT_INFORMATION_CLASS
{
  ObjectBasicInformation,
  ObjectNameInformation,
  ObjectTypeInformation,
  ObjectAllInformation,
  ObjectDataInformation
};

struct UNICODE_STRING
{
  WORD  Length;
  WORD  MaximumLength;
  PWSTR Buffer;
};

struct FILE_NAME_INFORMATION
{
  ULONG FileNameLength;
  WCHAR FileName[1];
};

struct SYSTEM_HANDLE
{
  USHORT ProcessId;
  USHORT CreatorBackTraceIndex;
  UCHAR  ObjectTypeIndex;
  UCHAR  HandleAttributes;
  USHORT HandleValue;
  PVOID  Object;
  ULONG  GrantedAccess;
};

struct SYSTEM_HANDLE_INFORMATION
{
  ULONG         Count;
  SYSTEM_HANDLE Handles[1];
};

struct NTFUNC_THREAD_PARAMS
{
  HANDLE Handle;
  TCHAR  *Buffer;
  WORD   BufferLength;
  TCHAR  *OutBuffer;
  WORD   OutBufferLength;
  int    ObjectInformationClass;
};

struct FILE_INFORMATION
{
  DWORD     ProcessId;
  TCHAR     FullPath[MAX_PATH];
  TCHAR     ProcessCaption[128];
  HWND      ProcessHWND;
  TCHAR     ProcessFullPath[MAX_PATH];
  long      FileNumber;
  long      TotalFiles;
};

typedef BOOL (CALLBACK*ENUM_LOCKED_FILES)(FILE_INFORMATION, LPARAM);
typedef BOOL (CALLBACK*ENUM_PROCESS_IDS)(DWORD, LPARAM);
typedef BOOL (CALLBACK*ENUM_APPLICATIONS)(FILE_INFORMATION, LPARAM);

struct ENUM_APPLICATIONS_PARAMS
{
  int               count;
  int               number;
  LPARAM            lParam;
  ENUM_APPLICATIONS lpEnumApplications;
};

BOOL WINAPI EnumSystemHandles(ENUM_LOCKED_FILES, LPARAM);
BOOL WINAPI EnumSystemModules(ENUM_LOCKED_FILES, LPARAM);
BOOL WINAPI EnumProcessIds(ENUM_PROCESS_IDS, LPARAM);
BOOL WINAPI EnumApplications(ENUM_APPLICATIONS, LPARAM);

void GetFileFromPath(TCHAR *, int, TCHAR *, int);
void FinishEnumeratingNow();
BOOL EndsWith(TCHAR *, const TCHAR *);

#endif